cls
@echo off
setlocal enabledelayedexpansion
color 0A
set Hinweis=Bitte lesen Sie unbedingt die Anleitungen zu diesem Skript in c't 02/15!

echo.
echo *********************************
echo *** Willkommen bei c't-wimage ***
echo *********************************
echo.
echo %hinweis%
echo.
echo Dieses Skript verbindet wie im Artikel beschrieben 
echo die Boot- und die Datenpartition der USB-Festplatte.
echo.

rem Hilfe erwuenscht?
if /i "%1"=="/?" goto hilfe
if /i "%1"=="-?" goto hilfe
if /i "%1"=="/h" goto hilfe
if /i "%1"=="-h" goto hilfe
if /i "%1"=="--h" goto hilfe
if /i "%1"=="/help" goto hilfe
if /i "%1"=="-help" goto hilfe
if /i "%1"=="--help" goto hilfe

echo *** Einige Pruefungen vorab ... ***
echo.

set operation=*** Skript braucht mindestens Windows 8.1 ***
for /f "tokens=3" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"currentversion^"') do set version=%%a
if %version% lss 6.3 goto fehler1

set operation=*** Dieses Skript ist nur fuer 64-Bit-Windows ***
if not exist "%ProgramFiles(x86)%" goto fehler1

set operation=*** Skript muss mit Administratorrechten laufen ***
whoami /groups | find "S-1-16-12288" > nul
if errorlevel 1 goto fehler1

set operation=*** Daten-Partition auf aktuelles Laufwerk festlegen ***
set usbdaten=%~d0

set operation=*** Auf der Datenpartition muessen Installationsdateien liegen ***
if not exist %usbdaten%\sources goto Fehler1
if not exist %usbdaten%\setup.exe goto Fehler1

set operation=*** Es sind 64-Bit-Installationsdateien erforderlich ***
dir /b %usbdaten%\sources\sxs | find /i "amd64" > nul
if errorlevel 1 goto fehler1

set operation=*** Boot-Partition abfragen ***
rem Auf welcher Partition liegt das aktuelle logische Laufwerk?
set partition=
wmic LogicalDisk where (DeviceID="%usbdaten%") assoc /assocclass:Win32_LogicalDiskToPartition > wmi.txt
if errorlevel 1 goto booteingabe
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-28!"=="Win32_DiskPartition.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set partition=%%P
  )
)
if "%partition%"=="" goto booteingabe
rem Auf welchem physikalischen Laufwerk liegt diese Partition?
set drive=
wmic Partition where (DeviceID="%partition%") assoc /assocclass:Win32_DiskDriveToDiskPartition > wmi.txt
if errorlevel 1 goto booteingabe
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-24!"=="Win32_DiskDrive.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set drive=%%P
  )
)
if "%drive%"=="" goto booteingabe
rem Welche Partitionen gibt es noch auf diesem Laufwerk?
set otherpart=
set bootpart=
wmic DiskDrive where (DeviceID="%drive%") assoc /assocclass:Win32_DiskDriveToDiskPartition > wmi.txt
if errorlevel 1 goto booteingabe
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-28!"=="Win32_DiskPartition.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set otherpart=%%P
    if not "!otherpart!"=="%partition%" (
      if "!bootpart!"=="" (
        set bootpart=!otherpart!
      ) else (
        set bootpart=undefined
      )
    )
  )
)
if "%bootpart%"=="undefined" goto booteingabe
if "%bootpart%"=="" goto booteingabe
rem Welches logische Laufwerk steckt in dieser Partition?
set otherdisk=
set usbboot=
wmic Partition where (DeviceID="%bootpart%") assoc /assocclass:Win32_LogicalDiskToPartition > wmi.txt
if errorlevel 1 goto booteingabe
for /f "tokens=1,2* delims==" %%X in ('type wmi.txt') do (
  set first=%%X
  if "!first:~-26!"=="Win32_LogicalDisk.DeviceID" (
    set second=%%Y
    set second=!second:"=$!
    for /f "tokens=1 delims=$" %%P in ("!second!") do set otherdisk=%%P
    if "!usbboot!"=="" (
      set usbboot=!otherdisk!
    ) else (
      set usbboot=undefined
    )
  )
)
if "%usbboot%"=="undefined" goto booteingabe
if "%usbboot%"=="" goto booteingabe
goto weiter1

:booteingabe
echo "Boot-Partition nicht (oder nicht eindeutig) bestimmbar."
set /p usbboot=Laufwerksbuchstabe der Partition USB-Boot64:
if "%usbboot%"=="" goto fehler2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

:weiter1
echo.
echo Laufwerksbuchstabe der Partition USB-Boot64: %usbboot%
echo Laufwerksbuchstabe der Partition USB-Daten64: %usbdaten%
choice /m "Einverstanden "
if not errorlevel 2 goto weiter2

set /p usbboot=Laufwerksbuchstabe der Partition USB-Boot64:
if "%usbboot%"=="" goto fehler2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

set /p usbdaten=Laufwerksbuchstabe der Partition USB-Daten64:
if "%usbboot%"=="" goto fehler2
if "%usbboot:~-1%"=="\" set usbboot=%usbboot:~0,-1%
if not "%usbboot:~-1%"==":" set usbboot=%usbboot%:

:weiter2
set operation=*** Auf der ausgewaehlten Partition muss ein bcd-Store vorhanden sein ***
if not exist %usbboot%\boot\bcd goto Fehler1
if not exist %usbboot%\efi\microsoft\boot\bcd goto Fehler1

set operation=*** Es darf nicht der Bootloader des laufenden Windows gewaehlt werden ***
bcdedit /store %usbboot%\boot\bcd | find /i "{current}" >nul
if errorlevel 2 goto fehler1
if %errorlevel% equ 0 goto fehler1
bcdedit /store  %usbboot%\efi\microsoft\boot\bcd | find /i "{current}" >nul
if errorlevel 2 goto fehler1
if %errorlevel% equ 0 goto fehler1

set operation=*** Es muss der Bootloader eines Windows PE/RE gewaehlt sein ***
bcdedit /store %usbboot%\boot\bcd | find /i "ramdisk" >nul
if errorlevel 1 goto fehler1
bcdedit /store  %usbboot%\efi\microsoft\boot\bcd | find /i "ramdisk" >nul
if errorlevel 1 goto fehler1

set operation=*** Bootloader anpassen ***
bcdedit /store %usbboot%\efi\microsoft\boot\bcd /set {default} device ramdisk=[%usbdaten%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fehler2
bcdedit /store %usbboot%\efi\microsoft\boot\bcd /set {default} osdevice ramdisk=[%usbdaten%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fehler2
bcdedit /store %usbboot%\boot\bcd /set {default} device ramdisk=[%usbdaten%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fehler2
bcdedit /store %usbboot%\boot\bcd /set {default} osdevice ramdisk=[%usbdaten%]\sources\boot.wim,{7619dcc8-fafe-11d9-b411-000476eba25f} > nul
if errorlevel 1 goto fehler2

set operation=*** ei.cfg anpassen ***
echo [EditionID] > %usbdaten%\sources\ei.cfg
if errorlevel 1 goto fehler2
echo. >> %usbdaten%\sources\ei.cfg
echo [Channel] >> %usbdaten%\sources\ei.cfg
echo OEM >> %usbdaten%\sources\ei.cfg
echo. >> %usbdaten%\sources\ei.cfg
echo [VL] >> %usbdaten%\sources\ei.cfg
echo 0 >> %usbdaten%\sources\ei.cfg
if errorlevel 1 goto fehler2

echo Fertig!
pause
goto :eof

rem Bedingung nicht erfllt
:fehler1
set text=Folgende Bedingung wurde nicht erfuellt: 
goto Fehlerausgabe

rem Fehler bei der Durchfuehrung
:fehler2
set text=Operation fehlgeschlagen:
goto Fehlerausgabe

:fehlerausgabe
color 0C
echo.
echo %text%
echo.
echo %operation%
echo.
echo %hinweis%
echo.
pause
goto :eof


:hilfe
echo.
echo %~nx0 biegt den Bootloader auf der Partition USB-Boot64 so um, dass
echo er Setup.exe von der Partition USB-Daten64 startet
echo. 
echo %~nx0 muss mit Administratorrechten gestartet werden!
echo.
echo %Hinweis%
pause>nul
goto :eof
;
REM Erstellt 2014 von Axel Vahldiek und Hajo Schulz/c't
REM mailto: axv@ct.de